include "console.iol"
include "common.iol"

outputPort Server {
  Location: "socket://localhost:8000"
  Protocol: sodep
  Interfaces: SumServerInterface
}

main
{
  pippo.session.userID = "Pippo";
  pluto.session.userID = "Pluto";

  login@Server( pippo.session );
  println@Console( "Pippo logged in" )();
  login@Server( pluto.session );
  println@Console( "Pluto logged in" )();
  
  pluto.add.addend = 5;
  pluto.add.userID = pluto.session.userID;
  add@Server( pluto.add );
  pluto.add.addend = 15;
  add@Server( pluto.add );

  pippo.add.addend = 7;
  pippo.add.userID = pippo.session.userID;
  add@Server( pippo.add );
  pippo.add.addend = 1;
  add@Server( pippo.add );

  sum@Server( pluto.session )( pluto.sum.response );
  sum@Server( pippo.session )( pippo.sum.response );
  println@Console( "Sum Pluto: " + pluto.sum.response )();
  println@Console( "Sum Pippo: " + pippo.sum.response )()
  
}